#include "external"

unsigned  External::target(struct in_addr clientip,
		     BackendVector const &targetlist) {
    
    // Prepare command to run
    ostringstream o;
    o << config.externalalgorithm() << ' ' << balancer.nbackends();
    for (unsigned i = 0; i < balancer.nbackends(); i++)
	o << ' ' << balancer.backend(i).description() << ' '
	  << balancer.backend(i).availablestr()
	  << ' ' << balancer.backend(i).connections();
    msg ("External algorithm: invoking '" + o.str() + "'\n");

    FILE *f;
    if (! (f = popen (o.str().c_str(), "r")) )
	throw static_cast<Error>("Cannot start '") + o.str() + "': " +
	    strerror(errno);
    unsigned i;
    if (fscanf (f, "%u", &i) < 1)
	throw static_cast<Error>("External algorithm '") + o.str() +
	    "' did not reply with a number";

    msg ((Mstr("External algorithm says:) ") + i) + "\n");

    if (i >= balancer.nbackends())
	throw static_cast<Error>("External algorithm '") + o.str() +
	    "': answer " + i + " out of bounds";
    if (pclose (f))
	throw static_cast<Error>("External algorithm '") + o.str() +
	    "' terminated with error";

    return (i);
}
