#include "leastconn"

unsigned Leastconn::target(struct in_addr clientip,
			   BackendVector const &targetlist) {

    PROFILE("Leastconn::target");
    
    bool found = false;
    unsigned nconn = 0, t = 0;

    for (unsigned i = 0; i < targetlist.size(); i++) {
	if (! balancer.backend(targetlist[i]).available())
	    continue;
	unsigned weighted_conn =
	    balancer.backend(targetlist[i]).connections() *
	    balancer.backend(targetlist[i]).adjustedweight();
	msg ("Back end " + balancer.backend(targetlist[i]).description() +
	     (Mstr(": connections ")
	      + balancer.backend(targetlist[i]).connections()) +
	     (Mstr(", adjusted weight ") +
	      balancer.backend(targetlist[i]).adjustedweight()) +
	     (Mstr(", weighted connections ") + weighted_conn) +
	     "\n");
	
	if (!found || weighted_conn < nconn) {
	    t = targetlist[i];
	    nconn = balancer.backend(t).connections();
	    found = true;
	}
    }


    if (!found)
	throw static_cast<Error>
	    ("Least-connections algorithm: no available back ends");
    return (t);
}
