#include "balancer"

void Balancer::init() {
    // Set the listening socket.
    if (config.sport())
	server_fd = serversocket (config.sipaddr(), config.sport(),
				  "balancer");
    else
	server_fd = 0;

    // Start the web interface if requested.
    if (config.usewebinterface()) {
	Webinterface *w = new Webinterface();
	if (! w)
	    throw static_cast<Error>("Memory fault in Balancer::init");
	w->start();
    }

    // Add workable back ends, display initial states.
    for (int i = 0; i < config.backends(); i++)
	addbackend (config.backend(i));

    for (unsigned i = 0; i < nbackends(); i++)
	msg ("Initial backend state: " + backend(i).description() + " is " +
	     backend(i).availablestr() + "\n");
}
