#include "dnsentry"

in_addr_t &DNSEntry::resolve (string const &h) {
    // If the entry is there and if it's up to date, run with it
    if (result && timestamp.elapsed() <= (double)config.dnscachetimeout())
	return result;

    // Resolve now.
    struct hostent *hostaddr;
    Mutex::lock((void*)gethostbyname);
    if ( (hostaddr = gethostbyname(h.c_str())) )
	memcpy (&result, hostaddr->h_addr_list[0], hostaddr->h_length);
    Mutex::unlock((void*)gethostbyname);

    if (!hostaddr)
	throw static_cast<Error>("Failed to resolve host '") + h + "'";

    debugmsg(Mstr("Host ") + h + "resolved\n");
    return result;
}
