#include "tcpdispatcher"

void TcpDispatcher::handle() {
    
    debugmsg (Mstr("TCP dispatcher: About to shuttle between client fd ") +
	      clientfd() +
	      (Mstr(" and backend fd ") + backendfd()) + "\n");
    
    while (1) {
	Fdset readset (config.client_timeout());
	readset.add (clientfd());
	readset.add (backendfd());
	
	int sock;
	if ((sock = readset.readable()) < 0)
	    break;
	if (!netbuffer.netread(sock))
	    break;

	int othersock, timeout;
	if (sock == clientfd()) {
	    othersock = backendfd();
	    timeout = config.backend_timeout();
	} else {
	    othersock = clientfd();
	    timeout = config.client_timeout();
	}

	debugmsg (Mstr("Had data on ") + sock +
		  (Mstr(", sending to ") + othersock) + "\n");

	netbuffer.netwrite (othersock, timeout);
	if (sock == backendfd())
	    balancer.backend(targetbackend()).addbytes(netbuffer.bufsz());

	netbuffer.reset();
    }
}
