#include "webinterface"

void Webinterface::answer_status() {
    string xml =
	"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
	"<?xml-stylesheet type=\"text/xsl\" href=\"/xslt\"?>\n"
	"<status>\n";

    ostringstream o;
    o <<
	"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
	"<?xml-stylesheet type=\"text/xsl\" href=\"/xslt\"?>\n"
	"<status>\n"
	"  <id>\n"
	"    <version>" << VER << "</version>\n"
	"    <distsite>" << DISTSITE << "</distsite>\n"
	"  </id>\n"
	"  <server>\n"
	"    <address>" << config.sipaddr() << ":" << config.sport() << "</address>\n"
	"    <type>" << config.stypestr() << "</type>\n"
	"    <clienttimeout>" << config.client_timeout() << "</clienttimeout>\n"
	"    <backendtimeout>" << config.backend_timeout() << "</backendtimeout>\n"
	"    <dispatchmode>" << config.dispatchmodestr() << "</dispatchmode>\n"
	"    <webinterface>" << config.webinterfaceip() << ':' << config.webinterfaceport() << "</webinterface>\n"
	"    <dnscachetimeout>" << config.dnscachetimeout() << "</dnscachetimeout>\n"
	"    <buffersize>" << config.buffersize() << "</buffersize>\n"
	"    <closesocketsfast>" << config.fastclose() << "</closesocketsfast>\n"
	"    <checks>\n"
	"      <wakeupinterval>" << config.wakeupsec() << "</wakeupinterval>\n"
	"      <checkupinterval>" << config.checkupsec() << "</checkupinterval>\n"
	"    </checks>\n"
	"    <debugging>\n"
	"      <verbose>" << config.verbose() << "</verbose>\n"
	"      <debug>" << config.debug() << "</debug>\n"
	"      <logtrafficdir>" << config.dumpdir() << "</logtrafficdir>\n"
	"    </debugging>\n"
	"    <dosprotection>\n"
	"      <maxconnections>" << config.maxconn() << "</maxconnections>\n"
	"      <timeinterval>" << config.connrate_time() << "</timeinterval>\n"
	"      <hardmaxconnrate>" << config.hardmaxconnrate() << "</hardmaxconnrate>\n"
	"      <softmaxconnrate>" << config.softmaxconnrate() << "</softmaxconnrate>\n"
	"      <defertime>" << config.defertime() << "</defertime>\n"
	"      <hardmaxconnexcess>" << config.hardmaxconnexcess() << "</hardmaxconnexcess>\n"
	"      <softmaxconnexcess>" << config.softmaxconnexcess() << "</softmaxconnexcess>\n"
	"    </dosprotection>\n"
	"    <acl>\n"
	"      <allow>\n";
    for (unsigned i = 0; i < config.nallow(); i++)
	o <<
	    "        <allowfrom>\n"
	    "          <nr>" << i << "</nr>\n"
	    "          <mask>" << inet_ntoa(config.allow(i)) << "</mask>\n"
	    "        </allowfrom>\n";
    o <<
	"      </allow>\n"
	"      <deny>\n";
    for (unsigned i = 0; i < config.ndeny(); i++)
	o <<
	    "        <denyfrom>\n"
	    "          <nr>" << i << "</nr>\n"
	    "          <mask>" << inet_ntoa(config.deny(i)) << "</mask>\n"
	    "        </denyfrom>\n";
    o <<
	"      </deny>\n"
	"    </acl>\n"
	"    <http>\n"
	"      <addxrversion>" << config.addxrversion() << "</addxrversion>\n"
	"      <addxforwardedfor>" << config.addxforwardedfor() << "</addxforwardedfor>\n"
	"      <stickyhttp>" << config.stickyhttp() << "</stickyhttp>\n"
	"      <serverheaders>\n"
	;
    for (unsigned i = 0; i < config.nserverheaders(); i++)
	o <<
	    "        <serverheader>\n"
	    "          <nr>" << i << "</nr>\n"
	    "          <header>" << config.serverheader(i) << "</header>\n"
	    "        </serverheader>\n"
	    ;
    o <<
	"      </serverheaders>\n"
	"    </http>\n"
	"    <backends>" << balancer.nbackends() << "</backends>\n"
	"    <terminating>" << balancer.terminate() << "</terminating>\n"
	"    <connections>" << balancer.connections() << "</connections>\n"
	"  </server>\n"
	;

    for (unsigned i = 0; i < balancer.nbackends(); i++)
	o <<
	    "  <backend>\n"
	    "    <nr>" << i << "</nr>\n"
	    "    <address>" << balancer.backend(i).description() << "</address>\n"
	    "    <weight>" << balancer.backend(i).weight() << "</weight>\n"
	    "    <maxconnections>" << balancer.backend(i).maxconn() << "</maxconnections>\n"
	    "    <loadavg>" << balancer.backend(i).loadavg() << "</loadavg>\n"
	    "    <up>" << balancer.backend(i).upstr() << "</up>\n"
	    "    <live>" << balancer.backend(i).livestr() << "</live>\n"
	    "    <available>" << balancer.backend(i).availablestr() << "</available>\n"
	    "    <connections>" << balancer.backend(i).connections() << "</connections>\n"
	    "    <bytesserved>" << balancer.backend(i).bytesserved() << "</bytesserved>\n"
	    "    <clientsserved>" << balancer.backend(i).clientsserved() << "</clientsserved>\n"
	    "    <hostmatch>" << balancer.backend(i).hostmatch() << "</hostmatch>\n"
	    "    <backendcheck>" << balancer.backend(i).backendcheck().setting() << "</backendcheck>\n"
	    "  </backend>\n"
	    ;

    o << "  <activity>\n";
    for (Threadmap::iterator it = Threadlist::map().begin();
	 it != Threadlist::map().end();
	 it++) {
	pthread_t thread_id = (*it).first;
	Threadinfo thread_info = (*it).second;
	o <<
	    "    <thread>\n"
	    "      <id>" << thread_id << "</id>\n"
	    "      <description>" << thread_info.desc() << "</description>\n"
	    "      <backend>" << thread_info.backend() << "</backend>\n"
	    "      <address>";
	if (thread_info.backend() >= 0)
	    o << balancer.backend(thread_info.backend()).description();
	o <<
	    "</address>\n"
	    "      <duration>" << thread_info.timestamp().elapsed() << "</duration>\n"
	    "    </thread>\n";
    }
    o << "  </activity>\n";
	 
    o <<
	"</status>\n\n";

    answer_blob (o.str());
}
